VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_apollonius_problem"
   ClientHeight    =   5820
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   6120
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkCircle 
      Caption         =   "8"
      Height          =   255
      Index           =   7
      Left            =   3480
      TabIndex        =   9
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "7"
      Height          =   255
      Index           =   6
      Left            =   3000
      TabIndex        =   8
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "6"
      Height          =   255
      Index           =   5
      Left            =   2520
      TabIndex        =   7
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "5"
      Height          =   255
      Index           =   4
      Left            =   2040
      TabIndex        =   6
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "4"
      Height          =   255
      Index           =   3
      Left            =   1560
      TabIndex        =   5
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "3"
      Height          =   255
      Index           =   2
      Left            =   1080
      TabIndex        =   4
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "2"
      Height          =   255
      Index           =   1
      Left            =   600
      TabIndex        =   3
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
   Begin VB.CommandButton cmdNone 
      Caption         =   "None"
      Height          =   375
      Left            =   4800
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdAll 
      Caption         =   "All"
      Height          =   375
      Left            =   4080
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.CheckBox chkCircle 
      Caption         =   "1"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Value           =   1  'Checked
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' True to not refresh when CheckBoxes change.
Private IgnoreRefresh As Boolean

' The given circles.
Private GivenCircles(0 To 2) As MyCircle

' The solutions.
Private SolutionCircles As Collection

' Colors to draw solutions.
Private Colors(1 To 8) As OLE_COLOR

Private Sub Form_Load()
Dim i As Integer

    Me.ScaleMode = vbPixels
    IgnoreRefresh = False

    ' Set the colors to use.
    Colors(1) = vbRed
    Colors(2) = vbGreen
    Colors(3) = vbBlue
    Colors(4) = RGB(255, 128, 0)
    Colors(5) = RGB(255, 255, 0)
    Colors(6) = RGB(0, 128, 255)
    Colors(7) = RGB(0, 128, 0)
    Colors(8) = RGB(255, 0, 255)

    ' Initialize the given circles.
    For i = 0 To 2
        Set GivenCircles(i) = New MyCircle
    Next i
    GivenCircles(0).Initialize 120, 115, 50
    GivenCircles(1).Initialize 160, 250, 70
    GivenCircles(2).Initialize 280, 130, 60

    ' Find the solutions.
    FindApollonianCircles
End Sub

' Check or uncheck all CheckBoxes.
Private Sub cmdAll_Click()
    IgnoreRefresh = True
    SetCheckboxes 1
    IgnoreRefresh = False
    Refresh
End Sub
Private Sub cmdNone_Click()
    IgnoreRefresh = True
    SetCheckboxes 0
    IgnoreRefresh = False
    Refresh
End Sub
Private Sub SetCheckboxes(ByVal is_checked As Integer)
Dim i As Integer

    For i = chkCircle.LBound To chkCircle.UBound
        chkCircle(i).Value = is_checked
    Next i
End Sub

' Draw the circles.
Private Sub Form_Paint()
Dim i As Integer
Dim solution_circle As MyCircle
Dim given_circle As MyCircle

    ' Draw the solution circles.
    Me.FillStyle = vbFSTransparent
    For i = 1 To SolutionCircles.Count
        If (chkCircle(i - 1).Value = vbChecked) Then
            Set solution_circle = SolutionCircles(i)
            If (Not solution_circle Is Nothing) Then
                solution_circle.Draw Me, Colors(i)
            End If
        End If
    Next i

    ' Draw the given circles.
    For i = 0 To UBound(GivenCircles)
        Me.FillStyle = vbFSSolid
        Me.FillColor = RGB(128, 128, 128)
        GivenCircles(i).Draw Me, vbBlack
    Next i
End Sub

' Find the circles that touch each of the three input circles.
Private Sub FindApollonianCircles()
Dim s0 As Integer
Dim s1 As Integer
Dim s2 As Integer
Dim new_circle As MyCircle

    ' Make a list for results.
    Set SolutionCircles = New Collection

    ' Loop over all of the signs.
    For s0 = -1 To 1 Step 2
        For s1 = -1 To 1 Step 2
            For s2 = -1 To 1 Step 2
                Set new_circle = FindApollonianCircle( _
                    GivenCircles(0), GivenCircles(1), GivenCircles(2), _
                    s0, s1, s2)
                If (Not new_circle Is Nothing) Then SolutionCircles.Add new_circle
            Next s2
        Next s1
    Next s0
End Sub

' Find a solution to Apollonius' problem.
' For discussion and method, see:
'    http://mathworld.wolfram.com/ApolloniusProblem.html
'    http://en.wikipedia.org/wiki/Problem_of_Apollonius#Algebraic_solutions
' For most of a Java code implementation, see:
'    http://www.diku.dk/hjemmesider/ansatte/rfonseca/implementations/apollonius.html
Private Function FindApollonianCircle(ByVal c1 As MyCircle, ByVal c2 As MyCircle, ByVal c3 As MyCircle, ByVal s1 As Integer, ByVal s2 As Integer, ByVal s3 As Integer) As MyCircle
Const tiny As Single = 0.0001

Dim temp_circle As MyCircle
Dim temp_s As Integer
Dim x1 As Single
Dim y1 As Single
Dim r1 As Single
Dim x2 As Single
Dim y2 As Single
Dim r2 As Single
Dim x3 As Single
Dim y3 As Single
Dim r3 As Single
Dim v11 As Single
Dim v12 As Single
Dim v13 As Single
Dim v14 As Single
Dim v21 As Single
Dim v22 As Single
Dim v23 As Single
Dim v24 As Single
Dim w12 As Single
Dim w13 As Single
Dim w14 As Single
Dim w22 As Single
Dim w23 As Single
Dim w24 As Single
Dim P As Single
Dim Q As Single
Dim M As Single
Dim N As Single
Dim a As Single
Dim b As Single
Dim c As Single
Dim solutions As Collection
Dim rs As Single
Dim xs As Single
Dim ys As Single
Dim new_circle As MyCircle

    ' Make sure c2 doesn't have the same X or Y coordinate as the others.
    If ((Abs(c2.X - c1.X) < tiny) Or (Abs(c2.Y - c1.Y) < tiny)) Then
        temp_circle = c2
        c2 = c3
        c3 = temp_circle
        temp_s = s2
        s2 = s3
        s3 = temp_s
    End If
    If ((Abs(c2.X - c3.X) < tiny) Or _
        (Abs(c2.Y - c3.Y) < tiny)) _
    Then
        temp_circle = c2
        c2 = c1
        c1 = temp_circle
        temp_s = s2
        s2 = s1
        s1 = temp_s
    End If

    x1 = c1.X
    y1 = c1.Y
    r1 = c1.Radius
    x2 = c2.X
    y2 = c2.Y
    r2 = c2.Radius
    x3 = c3.X
    y3 = c3.Y
    r3 = c3.Radius

    v11 = 2 * x2 - 2 * x1
    v12 = 2 * y2 - 2 * y1
    v13 = x1 * x1 - x2 * x2 + y1 * y1 - y2 * y2 - r1 * r1 + r2 * r2
    v14 = 2 * s2 * r2 - 2 * s1 * r1

    v21 = 2 * x3 - 2 * x2
    v22 = 2 * y3 - 2 * y2
    v23 = x2 * x2 - x3 * x3 + y2 * y2 - y3 * y3 - r2 * r2 + r3 * r3
    v24 = 2 * s3 * r3 - 2 * s2 * r2

    w12 = v12 / v11
    w13 = v13 / v11
    w14 = v14 / v11

    w22 = v22 / v21 - w12
    w23 = v23 / v21 - w13
    w24 = v24 / v21 - w14

    P = -w23 / w22
    Q = w24 / w22
    M = -w12 * P - w13
    N = w14 - w12 * Q

    a = N * N + Q * Q - 1
    b = 2 * M * N - 2 * N * x1 + 2 * P * Q - 2 * Q * y1 + 2 * s1 * r1
    c = x1 * x1 + M * M - 2 * M * x1 + P * P + y1 * y1 - 2 * P * y1 - r1 * r1

    ' Find roots of a quadratic equation
    Set solutions = QuadraticSolutions(a, b, c)
    If (solutions.Count < 1) Then
        Set FindApollonianCircle = Nothing
    Else
        rs = CSng(solutions(1))
        xs = M + N * rs
        ys = P + Q * rs
        Set new_circle = New MyCircle
        new_circle.Initialize xs, ys, rs
        Set FindApollonianCircle = new_circle
    End If
End Function

' Return solutions to a quadratic equation.
Private Function QuadraticSolutions(ByVal a As Double, ByVal b As Double, ByVal c As Double) As Collection
Const tiny As Double = 0.000001
Dim discriminant As Double
Dim results As Collection

    discriminant = b * b - 4 * a * c

    ' See if there are no real solutions.
    Set QuadraticSolutions = Nothing
    If (discriminant < 0) Then Exit Function

    ' See if there is one solution.
    Set results = New Collection
    If (discriminant < tiny) Then
        results.Add -b / (2 * a)
        Set QuadraticSolutions = results
        Exit Function
    End If

    ' There are two solutions.
    results.Add (-b + Sqr(discriminant)) / (2 * a)
    results.Add (-b - Sqr(discriminant)) / (2 * a)
    Set QuadraticSolutions = results
End Function

' Refresh.
Private Sub chkCircle_Click(Index As Integer)
    If (Not IgnoreRefresh) Then Refresh
End Sub
